apiVersion: {{ ds_apivers }}
kind: DaemonSet
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ nodeexporter_name }}
  name: {{ nodeexporter_name }}
  namespace: {{ namespace }}
spec:
  selector:
    matchLabels:
      name: {{ nodeexporter_name }}
  template:
    metadata:
      labels:
        name: {{ nodeexporter_name }}
    spec:
      automountServiceAccountToken: false
      containers:
      - args:
        - --path.procfs=/host/proc
        - --path.sysfs=/host/sys
        - --web.listen-address=0.0.0.0:9100
        name: node-exporter
        image: {{ (opsimages | json_query("[?name=='nodeexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /
            port: 9100
        ports:
        - name: metrics
          containerPort: 9100
        readinessProbe:
          httpGet:
            path: /
            port: 9100
        resources:
          limits:
            cpu: "{{ nodeexporter_cpu_limit }}"
            memory: {{ nodeexporter_memory_limit }}
          requests:
            cpu: "{{ nodeexporter_cpu_request }}"
            memory: {{ nodeexporter_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /host/proc
          name: proc
          readOnly:  true
        - mountPath: /host/sys
          name: sys
          readOnly: true
      hostNetwork: true
      hostPID: true
      nodeSelector:
{% for sel in nodeexporter_collect_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ nodeexporter_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: 65534
{% endif %}
      tolerations:
      - operator: Exists
      volumes:
      - name: proc
        hostPath:
          path: /proc
      - name: sys
        hostPath:
          path: /sys
  updateStrategy:
    type: RollingUpdate
